SystemOrganization addCategory: #KoCizen!

!CZDisplayPattern methodsFor: '*kocizen' stamp: 'sd 1/8/2012 18:51'!
filteredEntry

	CZEntry new
		fields! !

!CZDisplayPattern methodsFor: '*kocizen' stamp: 'sd 1/8/2012 18:53'!
filteredEntry: anEntry
	
	| cpy |
	cpy := anEntry copy.
	anEntry
	 
		! !

CZPersonalGenerator subclass: #ARBibCollectionBuilder
	instanceVariableNames: 'dispatchTag outbibset bibset originalBibset author2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KoCizen'!

!ARBibCollectionBuilder commentStamp: 'sd 1/7/2012 21:53' prior: 0!
Generate collection of bibitems based on tags.!

!ARBibCollectionBuilder class methodsFor: 'examples' stamp: 'sd 1/8/2012 15:20'!
forStef
	"self forStef"
	
	^ self new 
		author: '*Ducasse*';
		loadBib: 'rmod.bib'.
		
		! !

!ARBibCollectionBuilder methodsFor: 'accessing' stamp: 'sd 1/8/2012 09:01'!
author
	"copy from above for now because I hate CZDocument and I do not like the superclass too"
	
	^ author ifNil: [ author := '*Ducasse*']! !

!ARBibCollectionBuilder methodsFor: 'accessing' stamp: 'sd 1/8/2012 13:47'!
author: aString
	"copy from above for now because I hate CZDocument and I do not like the superclass too"
	
	 author := aString! !

!ARBibCollectionBuilder methodsFor: 'operation' stamp: 'sd 1/8/2012 21:33'!
collectionBasedOnKozenTag: aTag

	^ ARBibCollection new elements: (self filterKozenTag: aTag); yourself
	

! !

!ARBibCollectionBuilder methodsFor: 'operation' stamp: 'sd 1/8/2012 13:47'!
filter: aQuery
	
	^ (bibset entries select: [ :each | aQuery value: each])! !

!ARBibCollectionBuilder methodsFor: 'operation' stamp: 'sd 1/8/2012 14:27'!
filterKozenTag: aTag

	^ self filter:  (self queryForKozenTag: aTag).! !

!ARBibCollectionBuilder methodsFor: 'initialize' stamp: 'sd 1/8/2012 13:52'!
initializeBibSetFromPath: inputFile
	"self new createBibSetFromPath: 'rmod.bib'"
	
	bibset := originalBibset := CZFileLoader bibFromFileNamed: inputFile.! !

!ARBibCollectionBuilder methodsFor: 'operation' stamp: 'sd 1/8/2012 13:51'!
inputFileName:  inputFileString

	inputFileName := inputFileString! !

!ARBibCollectionBuilder methodsFor: 'operation' stamp: 'sd 1/8/2012 13:53'!
loadBib: aString

	self initializeBibSetFromPath: aString.
	self prepareForAuthor.
	! !

!ARBibCollectionBuilder methodsFor: 'accessing' stamp: 'sd 1/8/2012 14:08'!
originalBibset 

	^ originalBibset ! !

!ARBibCollectionBuilder methodsFor: 'private' stamp: 'sd 1/8/2012 13:48'!
prepareForAuthor
	
	| qu |
	qu := self withAuthor.
	bibset entries: (originalBibset entries select: [ :each | qu value: each])! !

!ARBibCollectionBuilder methodsFor: 'query' stamp: 'sd 1/8/2012 14:22'!
queryForKozenTag: aTag

	^ CZFieldQuery named: #keywords checks: [ :value | aTag match: value ]! !

!ARBibCollectionBuilder methodsFor: 'query' stamp: 'sd 1/8/2012 09:00'!
withAuthor
	^ CZFieldQuery named: #author checks: [ :value | self author match: value ]! !

ARList subclass: #ARBibCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KoCizen'!

!ARBibCollection commentStamp: 'sd 1/8/2012 17:21' prior: 0!
I'm a wrapper so that I can be put in a site structure but holding items of citezen.
during my visit the visitor can decide to invoke a citezen exporter. 

Not clear at the design level yet.!

!ARBibCollection methodsFor: 'as yet unclassified' stamp: 'sd 1/8/2012 17:22'!
accept: aVisitor

	aVisitor visitBibItemCollection: self! !

!ARBibCollection methodsFor: 'as yet unclassified' stamp: 'sd 1/8/2012 18:19'!
elements: aCol

	elements := aCol! !

CZHtmlOutputer subclass: #ARBibHTMLOutputer
	instanceVariableNames: 'fieldOrder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KoCizen'!

!ARBibHTMLOutputer methodsFor: 'accessing' stamp: 'sd 1/8/2012 20:46'!
fieldOrder
	^ fieldOrder! !

!ARBibHTMLOutputer methodsFor: 'accessing' stamp: 'sd 1/8/2012 20:46'!
fieldOrder: anObject
	fieldOrder := anObject! !

!ARBibHTMLOutputer methodsFor: 'initialize' stamp: 'sd 1/8/2012 20:45'!
initialize

	super initialize.
	fieldOrder := #(#author 
			  #title 
			  #journal 
			  #booktitle 
			  #volume 
			  #pages 
			  #publisher  
			  #year 
			  #impactfactor 
			  #rate 
			  #url 
			  #doi)! !

!ARBibHTMLOutputer methodsFor: 'visit' stamp: 'sd 1/8/2012 20:54'!
visitEntry: anEntry
	
	| fields |
	fields := anEntry fieldSortedFollowingKeys: fieldOrder. 
	outputStream 
		nextPutAll: '<li>'.
	fields
		 do: [ :each | each acceptVisitor: self]
		 separatedBy: [outputStream nextPutAll: ', '].
	outputStream nextPut: $. .
	outputStream 
		nextPutAll: '</li>'.! !
